module.exports = {
  'parser': 'babel-eslint',
  'extends': [
    'airbnb',
    'plugin:flowtype/recommended',
    './rule.global.js'
  ],
  'plugins': [
    'babel',
    'flowtype',
  ],
  'env': {
    'browser' : true,
  },
  'rules': {
    "_comment": "remove after https://github.com/babel/babel-eslint/issues/530 fix",
    "template-curly-spacing": "off",
    "indent": "off",
    // overwrite airbnb's config
    'react/destructuring-assignment': 0, // 其它eslint问题解决后重新启用
    'import/no-named-as-default': 0, // 其它eslint问题解决后重新启用
    'no-console': [2, { allow: ["warn", "error"] }],
    'jsx-a11y/anchor-is-valid': 0,
    "jsx-a11y/label-has-for": [2, {
      "components": ["Label"],
      "required": {
        "every": ["id"]
      },
      "allowChildren": false
    }],
    'no-underscore-dangle': 0,
    'react/sort-comp': [2, {
      order: [
        'type-annotations',
        'static-methods',
        'lifecycle',
        'everything-else',
        'render'
      ]
    }],
    'react/jsx-filename-extension': [1, { 'extensions': ['.js', '.jsx'] }],
    'import/no-extraneous-dependencies': 0,
    'no-param-reassign': [
      "error", { "ignorePropertyModificationsFor": ['draft'] }
    ],
  },
  settings: {
    "flowtype": {
      "onlyFilesWithFlowAnnotation": true
    },
  },
}
