// @flow
import React from 'react';
import { withAlert } from 'react-alert';

type Props = {
  downloadURL: string,
  alert: Object,
  title?: string,
}

export const DownloadFile = ({ downloadURL, alert, title }: Props) => {
  const downloadFile = async () => {
    try {
      const res = await fetch(downloadURL);
      if (res.status === 404) {
        alert.error('下载文件不存在');
      } else if (res.status === 200) {
        const elemIF = document.createElement('iframe');
        elemIF.src = downloadURL;
        elemIF.style.display = 'none';
        document.body.appendChild(elemIF);
      }
    } catch (e) {
      alert.error('下载文件不存在');
    }
  };
  return (
    <span
      className="contract-content"
      title={title}
      onClick={downloadFile}
      tabIndex={-1}
      onKeyPress={() => {}}
      role="button"
    >
      {title}
      <style jsx>
        {`
        .contract-content {
          color: #009EDC;
          cursor: pointer;
          font-weight: bold;
        }
      `}
      </style>
    </span>
  );
};
DownloadFile.defaultProps = {
  title: '下载',
};
export default withAlert(DownloadFile);
