// @flow
import React from 'react';

type Props = {
  title?: string,
  minHeight?: number | string,
}

const NoDataText = ({ title, minHeight = 0 }: Props) => (
  <div className="container">
    暂无
    {title || '数据'}
    <style jsx>
      {`
      .container {
        margin: auto;
        min-height: ${typeof (minHeight) === 'string' ? minHeight : `${minHeight}px`};
        line-height: ${typeof (minHeight) === 'string' ? minHeight : `${minHeight}px`};
        text-align: center;
        color: #ccc;
      }
      `}
    </style>
  </div>
);
NoDataText.defaultProps = {
  title: '数据',
  minHeight: 0,
};

export default NoDataText;
