// @flow
import { type ComponentType } from 'react';
import { connect } from 'react-redux';

import { removeLogins } from '../../store/serviceApp';

const mapStateToProps = state => ({
  user: state.user,
  loading: state.persist.loading,
});
const mapActionToProps = dispatch => ({
  logout: dispatch.user.logout,
  removeLogins,
});

const connectUser = (WrappedComponent: ComponentType<any>) => (
  connect(mapStateToProps, mapActionToProps)(WrappedComponent)
);

export default connectUser;
