// @flow
import React, { type ComponentType } from 'react';
import { withRouter } from 'next/router';

type Props = {
  router: Object
}

const judgeInLogin = (WrappedComponent: ComponentType<any>) => {
  const Comp = (props: Props) => {
    const loginPage = props.router.pathname === '/login';
    if (loginPage) { return false; }
    return <WrappedComponent {...props} />;
  };

  return withRouter(Comp);
};

export default judgeInLogin;
