// @flow
import React, { type ComponentType } from 'react';
import { connect } from 'react-redux';
import { uniFetch, uniFetchNA, handleFetchError } from '../../utils/fetch';

const mapStateToProps = state => ({
  user: state.user,
});

const withFetch = (WrappedComponent: ComponentType<any>) => {
  class FetchWithUser extends React.Component<Props, {}> {
    fetchWithUser = (url, options, ...rest) => {
      const { user } = this.props;
      return uniFetch(url, options, user, ...rest);
    }

    render() {
      return (
        <WrappedComponent
          {...this.props}
          {...{ fetchWithUser: this.fetchWithUser, uniFetchNA, handleFetchError }}
        />);
    }
  }
  const FetchWithUserWraper = connect(mapStateToProps, {})(FetchWithUser);
  return FetchWithUserWraper;
};


export default withFetch;
