const withCSS = require('@zeit/next-css');
const MonacoWebpackPlugin = require('monaco-editor-webpack-plugin');

if (typeof require !== 'undefined') {
  // eslint-disable-next-line
  require.extensions['.css'] = (file) => {};
}

module.exports = withCSS({
  cssModules: false,
  // 用_app.js加载样式，去掉以下配置
  // cssLoaderOptions: {
  //   importLoaders: 1,
  //   localIdentName: '[local]___[hash:base64:5]',
  // },
  plugins: [
    new MonacoWebpackPlugin(),
  ],
  webpack(config) {
    const originalEntry = config.entry;
    // eslint-disable-next-line
    config.entry = async () => {
      const entries = await originalEntry();

      if (entries['main.js'] && !entries['main.js'].includes('./utils/polyfills.js')) {
        entries['main.js'].unshift('./utils/polyfills.js');
      }

      return entries;
    };

    config.module.rules.push({
      test: /\.svg(\?v=\d+\.\d+\.\d+)?$/,
      // include: [/node_modules/],
      // issuer: {
      //   test: /\.js?$/,
      // },
      // use: ['url-loader'],
      use: [
        {
          loader: 'url-loader',
          options: {
            limit: 8192,
            fallback: 'file-loader',
            publicPath: '/_next/',
            outputPath: 'static/images/',
            name: '[name]-[hash].[ext]',
          },
        },
      ],
    });
    config.module.rules.push({
      test: /\.(png|woff|woff2|eot|ttf|svg|gif|jpg)$/,
      loader: 'file-loader',
      options: {
        publicPath: '/_next/static/',
        outputPath: 'static/',
      },
    });

    return config;
  },
});
module.export = {
  plugins: [
    new MonacoWebpackPlugin(),
  ],
};
