const precss = require('precss');
const atImport = require('postcss-import');
const url = require('postcss-url');
const path = require('path');

const options = [
  {
    filter: '**/fonts/fontawesome-webfont.*',
    basePath: path.resolve('node_modules/font-awesome/fonts'),
    url: 'copy',
    assetsPath: 'font-awesome',
    useHash: true,
  },
  {
    filter: '**/themes/default/assets/fonts/*icons.*',
    basePath: path.resolve('semantic/dist'),
    url: 'copy',
    assetsPath: 'assets',
    useHash: true,
  },
  {
    filter: '**/font/VideoJS.eot*',
    basePath: path.resolve('node_modules/video.js/dist'),
    url: 'copy',
    assetsPath: 'assets',
    useHash: true,
  },
  {
    filter: '**/assets/inline/*.svg', url: 'inline',
  },
  {
    filter: '**/assets/**/*.gif', url: 'rebase',
  },
  {
    filter: 'cdn/**/*', url: asset => `https://cdn.url/${asset.url}`,
  },
];

// { file, options, env }
module.exports = ({ file }) => {
  const inJSX = !file || file.basename !== 'index.css';

  if (inJSX) {
    return {
      plugins: [atImport, precss],
    };
  }

  return {
    plugins: [
      atImport,
      url(options),
      precss,
    ],
  };
};
