const express = require('express');
const next = require('next');
const env = require('../utils/env');

const port = parseInt(process.env.PORT, 10) || 3000;
const dev = process.env.NODE_ENV !== 'production';
const app = next({ dev });
const handle = app.getRequestHandler();

// TODO: load dotenv in production
if (!dev) {
  env.checkENV();
}

app.prepare()
  .then(() => {
    const server = express();

    // server.get('/operator/:page/:resource?/:childrender?', (req, res) => {
    //   const actualPage = '/operator';
    //   const queryParams = {
    //     page: req.params.page,
    //     resource: req.params.resource,
    //     childrender: req.params.childrender,
    //   };
    //   app.render(req, res, actualPage, queryParams);
    // });

    server.get('*', (req, res) => handle(req, res));

    server.listen(port, (err) => {
      if (err) throw err;
      console.log(`> Ready on http://localhost:${port}`);
    });
  })
  .catch((ex) => {
    console.error(ex.stack);
    process.exit(1);
  });
