import fetch from 'isomorphic-unfetch';

const github = {
  state: {
    users: [],
    isLoading: false,
  }, // initial state
  reducers: {
    requestUsers() {
      return {
        users: [],
        isLoading: true,
      };
    },
    receiveUsers(state, payload) {
      return {
        isLoading: false,
        users: payload,
      };
    },
    testSetUser(state, newName) {
      return { ...state, users: [newName] };
    },
  },
  effects: () => ({
    // handle state changes with impure functions.
    // use async/await for async actions
    async fetchUsers() {
      try {
        this.requestUsers();
        const response = await fetch('https://api.github.com/users');
        const users = await response.json();
        this.receiveUsers(users);
      } catch (err) {
        console.error(err);
        this.receiveUsers([]);
      }
    },
  }),
};

export default github;
