import { init } from '@rematch/core';
import createLoadingPlugin from '@rematch/loading';
import thunkMiddleware from 'redux-thunk';
import * as models from './models';

const loading = createLoadingPlugin({});
const initStore = (initialState = {}) => init({
  models,
  redux: {
    initialState,
    middlewares: [thunkMiddleware],
  },
  plugins: [loading],
});

export default initStore;
