const requiredENV = [
  'IAM_URL',
  'ORDERS_URL',
  'UPLOADFILE_URL',
  'EVALUATING_URL',
  'SERVICE_URL',
  'SERVICE_URL_SERVER',
  'RESOURCE_URL',
  'COST_URL',
  'SHOP_URL',
  'PAS_API_URL',
  'DS_URL',
  'OBJECT_URL',
  'AUTHZ_URL',
  'STATIC_URL',
  'CLUSTER_MONITOR_URL',
  'MONITOR_URL',
  'ASCCESS_LINK',
  'APPLICATION_SERVICE_URL',
  'APPLICATION_SERVICE_URL_SERVER',
  'APPLICATION_TOKEN',
  'RESOURCE_X_URL',
  'GROUP_INFO_X_URL',
  'DATA_SERVICE_X_URL',
  'YAW_DETECTION_URL',
  'REAL_TIME_DATA_URL',
  'PS_TOKEN',
  'PS_API_URL',
  'PS_DATA_URL',
  'PS_IMG_URL',
  'DATASET_URL',
  'GROUP_INFOP_PREV_X_URL',
];

const optionalENV = [
  'KMX_TOKEN',
];

function warning(name) {
  throw new Error(`miss env: ${name}!`);
}

function checkENV() {
  requiredENV.forEach((v) => {
    if (!process.env[v]) warning(v);
  });
}

function processENV() {
  const env = {};
  requiredENV.forEach((item) => {
    env[item] = process.env[item];
  });
  optionalENV.forEach((item) => {
    env[item] = process.env[item];
  });

  return env;
}

module.exports.checkENV = checkENV;

module.exports.processENV = processENV;

let env = typeof window !== 'undefined' ? window.__ENV__ : processENV();
env = env || {};
env.checkENV = checkENV;
env.processENV = processENV;

module.exports = env;
