export default function abbreviateNumber(value, precision = 3) {
  let newValue = value;
  if (value >= 10000) {
    const suffixes = ['', '万', '千万', '亿', '兆'];
    let suffixNum = Math.floor(((`${Math.floor(value)}`).length - 2) / 3);
    if (suffixNum > suffixes.length - 1) suffixNum = suffixes.length - 1;

    let shortValue = 0;
    for (let i = precision; i >= 1; i -= 1) {
      // TODO: check if toPrecision need
      shortValue = parseFloat((
        suffixNum !== 0
          ? (value / 10 / (1000 ** suffixNum))
          : value
      ).toPrecision(i));
      const dotLessShortValue = (`${shortValue}`).replace(/[^a-zA-Z 0-9]+/g, '');
      if (dotLessShortValue.length <= precision) { break; }
    }

    // if (shortValue % 1 !== 0) shortNum = shortValue.toFixed(1)
    newValue = shortValue + suffixes[suffixNum];
  }

  return newValue;
}
