// @flow
import globalENV from './env';

const PAS_ENV = {
  API_URL: globalENV.PAS_API_URL,
  DS_URL: globalENV.DS_URL,
  OBJECT_URL: globalENV.OBJECT_URL,
  AUTHZ_URL: globalENV.AUTHZ_URL,
  STATIC_URL: globalENV.STATIC_URL,
  USER_URL: '/',
  AUTH_API: true,
  SERVER_PATH: 'https://192.168.130.55:8443',
  SERVICE_PREFIX: 'http://localhost:3000',
};

const saveToken = (env: Object = {}) => {
  window.localStorage.setItem('pas', JSON.stringify(env));
};

const removeToken = () => {
  window.localStorage.removeItem('pas');
};

const syncENV = (env: Object = {}) => {
  Object.keys(env)
    .forEach((key) => {
      PAS_ENV[key] = env[key];
    });
  saveToken(env);
};


export { syncENV, removeToken };

export default PAS_ENV;
