// @flow

type Params = {
  url: string,
  userId: string,
  email: string,
  token: string,
}

type Elements = {
  form: HTMLFormElement,
  userId: HTMLInputElement,
  email: HTMLInputElement,
  token: HTMLInputElement,
}

let elements: ?Elements = null;

export default (params: Params) => {
  if (!elements) {
    const form = document.createElement('form');
    form.style.display = 'none';
    form.target = '_blank';
    form.method = 'post';

    const userId = document.createElement('input');
    userId.name = 'user_id';
    form.appendChild(userId);

    const email = document.createElement('input');
    email.name = 'email';
    form.appendChild(email);

    const token = document.createElement('input');
    token.name = 'token';
    form.appendChild(token);

    // $FlowFixMe
    document.body.appendChild(form);

    elements = {
      form,
      userId,
      email,
      token,
    };
  }

  const {
    form, userId, email, token,
  } = elements;
  const url = params.url && (params.url.startsWith('http') || params.url.startsWith('//'))
    ? params.url
    : `//${params.url}`;
  form.action = url;
  userId.value = params.userId;
  email.value = params.email;
  token.value = params.token;

  form.submit();
};
